unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, fpcsvexport, Forms, Controls, Graphics, Dialogs,
  DBGrids, StdCtrls, fpsDataset, ZMConnection, ZMQueryDataSet,
  fpspreadsheetctrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    CSVExporter1: TCSVExporter;
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    DBGrid1: TDBGrid;
    DBGrid2: TDBGrid;
    sWorksheetDataset1: TsWorksheetDataset;
    ZMConnection1: TZMConnection;
    ZMQueryDataSet1: TZMQueryDataSet;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure CopyRecord(DataSetOrigem, DataSetDestino: TDataSet);
var
  Field: TField;
begin
  DataSetOrigem.First;
  while not DataSetOrigem.EOF do
  begin
    DataSetDestino.Append;
    for Field in DataSetOrigem.Fields do
      DataSetDestino.Fields[Field.Index].Value := Field.Value;
    DataSetDestino.Post;
    DataSetOrigem.Next;
  end;
end;

{ TForm1 }

procedure TForm1.FormShow(Sender: TObject);
begin
  sWorkSheetDataset1.FileName := 'PlantList.xls';
  sWorkSheetDataset1.Open;
  ZMConnection1.DatabasePath := GetCurrentDir;
  ZMQueryDataSet1.TableName := 'PlantList';
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  db: string;
begin
  CSVExporter1.FileName := 'PlantList.csv';
  CSVExporter1.Execute;
  db := ZMQueryDataset1.ZMConnection.DatabasePath + '\' + ZMQueryDataset1.TableName;
  ZMQueryDataset1.LoadFromTable;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  FAMILY, SPECIES: string;
begin
  FAMILY := ZMQueryDataset1.Fields[2].FieldName;
  SPECIES := ZMQueryDataset1.Fields[3].FieldName;
  ZMQueryDataset1.SQL.Text := 'SELECT ' + FAMILY + ', ' + SPECIES +
    ' FROM PlantList GROUP BY ' + FAMILY + ', ' + SPECIES + ' ORDER BY ' +
    FAMILY + ', ' + SPECIES;
  ShowMessage(ZMQueryDataset1.SQL.Text);
  ZMQueryDataset1.QueryExecute;
  ZMQueryDataset1.First;
end;

end.
